<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/synstructure-0.12.6/src/macros.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>macros.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../synstructure/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../synstructure/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../synstructure/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
</pre><pre class="rust"><code><span class="doccomment">//! This module provides two utility macros for testing custom derives. They can</span>
<span class="doccomment">//! be used together to eliminate some of the boilerplate required in order to</span>
<span class="doccomment">//! declare and test custom derive implementations.</span>

<span class="comment">// Re-exports used by the decl_derive! and test_derive!</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">proc_macro2::TokenStream</span> <span class="kw">as</span> <span class="ident">TokenStream2</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">syn</span>::{<span class="ident">parse_str</span>, <span class="ident">DeriveInput</span>};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(
    <span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;wasm32&quot;</span>, <span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;unknown&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;wasi&quot;</span>))),
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;proc-macro&quot;</span>
))]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">proc_macro::TokenStream</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(
    <span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;wasm32&quot;</span>, <span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;unknown&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;wasi&quot;</span>))),
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;proc-macro&quot;</span>
))]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">syn::parse</span>;

<span class="doccomment">/// The `decl_derive!` macro declares a custom derive wrapper. It will parse the</span>
<span class="doccomment">/// incoming `TokenStream` into a `synstructure::Structure` object, and pass it</span>
<span class="doccomment">/// into the inner function.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Your inner function should take a `synstructure::Structure` by value, and</span>
<span class="doccomment">/// return a type implementing `synstructure::MacroResult`, for example:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// fn derive_simple(input: synstructure::Structure) -&gt; proc_macro2::TokenStream {</span>
<span class="doccomment">///     unimplemented!()</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// fn derive_result(input: synstructure::Structure)</span>
<span class="doccomment">///     -&gt; syn::Result&lt;proc_macro2::TokenStream&gt;</span>
<span class="doccomment">/// {</span>
<span class="doccomment">///     unimplemented!()</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Usage</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ### Without Attributes</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// fn derive_interesting(_input: synstructure::Structure) -&gt; proc_macro2::TokenStream {</span>
<span class="doccomment">///     quote::quote! { ... }</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # const _IGNORE: &amp;&#39;static str = stringify! {</span>
<span class="doccomment">/// decl_derive!([Interesting] =&gt; derive_interesting);</span>
<span class="doccomment">/// # };</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ### With Attributes</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// # fn main() {}</span>
<span class="doccomment">/// fn derive_interesting(_input: synstructure::Structure) -&gt; proc_macro2::TokenStream {</span>
<span class="doccomment">///     quote::quote! { ... }</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # const _IGNORE: &amp;&#39;static str = stringify! {</span>
<span class="doccomment">/// decl_derive!([Interesting, attributes(interesting_ignore)] =&gt; derive_interesting);</span>
<span class="doccomment">/// # };</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ### Decl Attributes &amp; Doc Comments</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// # fn main() {}</span>
<span class="doccomment">/// fn derive_interesting(_input: synstructure::Structure) -&gt; proc_macro2::TokenStream {</span>
<span class="doccomment">///     quote::quote! { ... }</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # const _IGNORE: &amp;&#39;static str = stringify! {</span>
<span class="doccomment">/// decl_derive! {</span>
<span class="doccomment">///     [Interesting] =&gt;</span>
<span class="doccomment">///     #[allow(some_lint)]</span>
<span class="doccomment">///     /// Documentation Comments</span>
<span class="doccomment">///     derive_interesting</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// # };</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// *This macro is available if `synstructure` is built with the `&quot;proc-macro&quot;`</span>
<span class="doccomment">/// feature.*</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(
    <span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;wasm32&quot;</span>, <span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;unknown&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;wasi&quot;</span>))),
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;proc-macro&quot;</span>
))]</span>
<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="macro">macro_rules!</span> <span class="ident">decl_derive</span> {
    <span class="comment">// XXX: Switch to using this variant everywhere?</span>
    ([<span class="macro-nonterminal">$</span><span class="macro-nonterminal">derives</span>:<span class="ident">ident</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">derive_t</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>] =&gt; $(<span class="attribute">#[$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">attrs</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>]</span>)<span class="op">*</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">inner</span>:<span class="ident">path</span>) =&gt; {
        <span class="attribute">#[<span class="ident">proc_macro_derive</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">derives</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">derive_t</span>)<span class="kw-2">*</span>)]</span>
        <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">non_snake_case</span>)]</span>
        $(<span class="attribute">#[$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">attrs</span>)<span class="kw-2">*</span>]</span>)<span class="op">*</span>
        <span class="kw">pub</span> <span class="kw">fn</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">derives</span>(
            <span class="ident">i</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::macros::TokenStream</span>
        ) -&gt; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::macros::TokenStream</span> {
            <span class="kw">match</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::macros::parse</span>::<span class="op">&lt;</span><span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::macros::DeriveInput</span><span class="op">&gt;</span>(<span class="ident">i</span>) {
                <span class="prelude-val">Ok</span>(<span class="ident">p</span>) =&gt; {
                    <span class="kw">match</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Structure::try_new</span>(<span class="kw-2">&amp;</span><span class="ident">p</span>) {
                        <span class="prelude-val">Ok</span>(<span class="ident">s</span>) =&gt; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::MacroResult::into_stream</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">inner</span>(<span class="ident">s</span>)),
                        <span class="prelude-val">Err</span>(<span class="ident">e</span>) =&gt; <span class="ident">e</span>.<span class="ident">to_compile_error</span>().<span class="ident">into</span>(),
                    }
                }
                <span class="prelude-val">Err</span>(<span class="ident">e</span>) =&gt; <span class="ident">e</span>.<span class="ident">to_compile_error</span>().<span class="ident">into</span>(),
            }
        }
    };
}

<span class="doccomment">/// The `decl_attribute!` macro declares a custom attribute wrapper. It will</span>
<span class="doccomment">/// parse the incoming `TokenStream` into a `synstructure::Structure` object,</span>
<span class="doccomment">/// and pass it into the inner function.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Your inner function should have the following type:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// fn attribute(</span>
<span class="doccomment">///     attr: proc_macro2::TokenStream,</span>
<span class="doccomment">///     structure: synstructure::Structure,</span>
<span class="doccomment">/// ) -&gt; proc_macro2::TokenStream {</span>
<span class="doccomment">///     unimplemented!()</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Usage</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// fn attribute_interesting(</span>
<span class="doccomment">///     _attr: proc_macro2::TokenStream,</span>
<span class="doccomment">///     _structure: synstructure::Structure,</span>
<span class="doccomment">/// ) -&gt; proc_macro2::TokenStream {</span>
<span class="doccomment">///     quote::quote! { ... }</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # const _IGNORE: &amp;&#39;static str = stringify! {</span>
<span class="doccomment">/// decl_attribute!([interesting] =&gt; attribute_interesting);</span>
<span class="doccomment">/// # };</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// *This macro is available if `synstructure` is built with the `&quot;proc-macro&quot;`</span>
<span class="doccomment">/// feature.*</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(
    <span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;wasm32&quot;</span>, <span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;unknown&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;wasi&quot;</span>))),
    <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;proc-macro&quot;</span>
))]</span>
<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="macro">macro_rules!</span> <span class="ident">decl_attribute</span> {
    ([<span class="macro-nonterminal">$</span><span class="macro-nonterminal">attribute</span>:<span class="ident">ident</span>] =&gt; $(<span class="attribute">#[$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">attrs</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>]</span>)<span class="op">*</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">inner</span>:<span class="ident">path</span>) =&gt; {
        <span class="attribute">#[<span class="ident">proc_macro_attribute</span>]</span>
        $(<span class="attribute">#[$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">attrs</span>)<span class="kw-2">*</span>]</span>)<span class="op">*</span>
        <span class="kw">pub</span> <span class="kw">fn</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">attribute</span>(
            <span class="ident">attr</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::macros::TokenStream</span>,
            <span class="ident">i</span>: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::macros::TokenStream</span>,
        ) -&gt; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::macros::TokenStream</span> {
            <span class="kw">match</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::macros::parse</span>::<span class="op">&lt;</span><span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::macros::DeriveInput</span><span class="op">&gt;</span>(<span class="ident">i</span>) {
                <span class="prelude-val">Ok</span>(<span class="ident">p</span>) =&gt; <span class="kw">match</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Structure::try_new</span>(<span class="kw-2">&amp;</span><span class="ident">p</span>) {
                    <span class="prelude-val">Ok</span>(<span class="ident">s</span>) =&gt; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::MacroResult::into_stream</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">inner</span>(<span class="ident">attr</span>.<span class="ident">into</span>(), <span class="ident">s</span>)),
                    <span class="prelude-val">Err</span>(<span class="ident">e</span>) =&gt; <span class="ident">e</span>.<span class="ident">to_compile_error</span>().<span class="ident">into</span>(),
                },
                <span class="prelude-val">Err</span>(<span class="ident">e</span>) =&gt; <span class="ident">e</span>.<span class="ident">to_compile_error</span>().<span class="ident">into</span>(),
            }
        }
    };
}

<span class="doccomment">/// Run a test on a custom derive. This macro expands both the original struct</span>
<span class="doccomment">/// and the expansion to ensure that they compile correctly, and confirms that</span>
<span class="doccomment">/// feeding the original struct into the named derive will produce the written</span>
<span class="doccomment">/// output.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// You can add `no_build` to the end of the macro invocation to disable</span>
<span class="doccomment">/// checking that the written code compiles. This is useful in contexts where</span>
<span class="doccomment">/// the procedural macro cannot depend on the crate where it is used during</span>
<span class="doccomment">/// tests.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Usage</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// fn test_derive_example(_s: synstructure::Structure)</span>
<span class="doccomment">///     -&gt; Result&lt;proc_macro2::TokenStream, syn::Error&gt;</span>
<span class="doccomment">/// {</span>
<span class="doccomment">///     Ok(quote::quote! { const YOUR_OUTPUT: &amp;&#39;static str = &quot;here&quot;; })</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// fn main() {</span>
<span class="doccomment">///     synstructure::test_derive!{</span>
<span class="doccomment">///         test_derive_example {</span>
<span class="doccomment">///             struct A;</span>
<span class="doccomment">///         }</span>
<span class="doccomment">///         expands to {</span>
<span class="doccomment">///             const YOUR_OUTPUT: &amp;&#39;static str = &quot;here&quot;;</span>
<span class="doccomment">///         }</span>
<span class="doccomment">///     }</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="macro">macro_rules!</span> <span class="ident">test_derive</span> {
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">name</span>:<span class="ident">path</span> { $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">i</span>:<span class="ident">tt</span>)<span class="op">*</span> } <span class="ident">expands</span> <span class="ident">to</span> { $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">o</span>:<span class="ident">tt</span>)<span class="op">*</span> }) =&gt; {
        {
            <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
            <span class="kw">fn</span> <span class="ident">ensure_compiles</span>() {
                $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">i</span>)<span class="op">*</span>
                $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">o</span>)<span class="op">*</span>
            }

            <span class="macro-nonterminal">$</span><span class="macro">crate::test_derive!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">name</span> { $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">i</span>)<span class="op">*</span> } <span class="ident">expands</span> <span class="ident">to</span> { $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">o</span>)<span class="op">*</span> } <span class="ident">no_build</span>);
        }
    };

    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">name</span>:<span class="ident">path</span> { $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">i</span>:<span class="ident">tt</span>)<span class="op">*</span> } <span class="ident">expands</span> <span class="ident">to</span> { $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">o</span>:<span class="ident">tt</span>)<span class="op">*</span> } <span class="ident">no_build</span>) =&gt; {
        {
            <span class="kw">let</span> <span class="ident">i</span> <span class="op">=</span> <span class="macro">stringify!</span>( $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">i</span>)<span class="op">*</span> );
            <span class="kw">let</span> <span class="ident">parsed</span> <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::macros::parse_str</span>::<span class="op">&lt;</span><span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::macros::DeriveInput</span><span class="op">&gt;</span>(<span class="ident">i</span>)
                .<span class="ident">expect</span>(<span class="macro">concat!</span>(
                    <span class="string">&quot;Failed to parse input to `#[derive(&quot;</span>,
                    <span class="macro">stringify!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">name</span>),
                    <span class="string">&quot;)]`&quot;</span>,
                ));

            <span class="kw">let</span> <span class="ident">raw_res</span> <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">name</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Structure::new</span>(<span class="kw-2">&amp;</span><span class="ident">parsed</span>));
            <span class="kw">let</span> <span class="ident">res</span> <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::MacroResult::into_result</span>(<span class="ident">raw_res</span>)
                .<span class="ident">expect</span>(<span class="macro">concat!</span>(
                    <span class="string">&quot;Procedural macro failed for `#[derive(&quot;</span>,
                    <span class="macro">stringify!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">name</span>),
                    <span class="string">&quot;)]`&quot;</span>,
                ));

            <span class="kw">let</span> <span class="ident">expected</span> <span class="op">=</span> <span class="macro">stringify!</span>( $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">o</span>)<span class="op">*</span> )
                .<span class="ident">parse</span>::<span class="op">&lt;</span><span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::macros::TokenStream2</span><span class="op">&gt;</span>()
                .<span class="ident">expect</span>(<span class="string">&quot;output should be a valid TokenStream&quot;</span>);
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">expected_toks</span> <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::macros::TokenStream2::from</span>(<span class="ident">expected</span>);
            <span class="kw">if</span> <span class="ident">res</span>.<span class="ident">to_string</span>() <span class="op">!</span><span class="op">=</span> <span class="ident">expected_toks</span>.<span class="ident">to_string</span>() {
                <span class="macro">panic!</span>(<span class="string">&quot;\
test_derive failed:
expected:
```
{}
```

got:
```
{}
```\n&quot;</span>,
                    <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::unpretty_print</span>(<span class="kw-2">&amp;</span><span class="ident">expected_toks</span>),
                    <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::unpretty_print</span>(<span class="kw-2">&amp;</span><span class="ident">res</span>),
                );
            }
        }
    };
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="synstructure" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>